package com.bergerkiller.bukkit.nolagg.monitor;

import org.bukkit.plugin.Plugin;

import com.bergerkiller.bukkit.common.config.FileConfiguration;
import com.bergerkiller.bukkit.nolagg.base.NoLaggBase;

public class NoLaggMonitor extends NoLaggBase {

	public static NoLaggMonitor plugin;
	public static boolean isChunkEnabled = false;
	public static boolean isTNTEnabled = false;
	public static boolean isLightingEnabled = false;
	
	@Override
	public void updateDependency(Plugin plugin, String pluginName, boolean enabled) {
		if (pluginName.equals("NoLaggChunks")) {
			isChunkEnabled = enabled;
		} else if (pluginName.equals("NoLaggTNT")) {
			isTNTEnabled = enabled;
		} else if (pluginName.equals("NoLaggLighting")) {
			isLightingEnabled = enabled;
		}
	}
	
	@Override
	public void reload() {
		PerformanceMonitor.deinit();
		FileConfiguration config = new FileConfiguration(this);
		config.load();
		config.setHeader("This is the configuration of NoLaggMonitor\n");
		config.setHeader("monitorInterval", "The interval at which new performance snapshots are generated");
		config.setHeader("startLoggingOnStartup", "Whether or not to start logging server performance on startup");
		PerformanceMonitor.monitorInterval = config.get("monitorInterval", 40);
		PerformanceMonitor.sendLog = config.get("startLoggingOnStartup", false);
		config.save();
		PerformanceMonitor.init();
	}
	
	@Override
	public void enable() {
		plugin = this;
		
		this.register(new Commands());
		this.register(NLMListener.class);
		
		this.reload();
	}

	@Override
	public void disable() {
		// TODO Auto-generated method stub
		
		PerformanceMonitor.deinit();
	}
	
	@Override
	public void permissions() {
		this.loadPermissions(Permission.class);
	}

}
